% script to generate library of motionally narrowed powder pattterns

clear ;   % clean out the workspace : NOTE save important results BEFORE RUNNING THIS SCRIPT

load narrowed.fig_param.mat
   % Change the .mat filename to load the one you want to start with
%
% specify new parameters: site populations, powder increments, eta, cq,
% etc. Modify and unncomment lines as desired 
%

CQ = linspace(35,45,11);
ncq = length(CQ)
np = size(param.fid,1);
sigs = zeros(np,ng);
npar = param;
tic  % start timer
for ll = 1:ncq                                   % (big) loop over distribution samples
    display(ll)                                  % print loop counter in case user gets bored
    npar.cq = [CQ(ll) CQ(ll)];                   % reset CQ
    sigs(:,ll) = staticsim(npar);              % re-run the simulation
end
toc
[specCQ,fax] = mpr(param,sigs); %  column j of specs is the line shape for the j-th jump angle
save CQlib