% script to calculate QE spectra for different arclenghts
% motional model: (depends on the start file)
%   fast methylrotation k3=default but unequal populations frame1=1:3:3
%   jumps on an arc in 10°-steps with equal populations
%   fast jumps on the arc k2=default, opening angle beta2=35°
%   variation of the arclength al

% !!!START FILE HAS TO BE FROM EXPRESSBETA.MARS2008!!!

load ???.fig_param.mat % load express file, uses these parameters as default parameters

almax = 100;                        % maximal arclength
almin = 20;                         % minimal arclenght
nocalc = size(almin:10:almax, 2);   % number of repetitions of the loop, 10=10°-steps
fids = cell(nocalc, 1);             % place for results
params = cell(nocalc, 1);           % place for results
specs = cell(nocalc, 1);            % place for results
frame1 = [1 3 3];                   % sitepopulations of the methylgroup
beta2 = 35;                         % opening angle of the cone of the arc
CQ = 90;                            % quadrupolar coupming constant in kHz
param.n = 28657;                    % powder increments
npts_exp = 32768;                   % number of experimental datapoints

for al = almin:10:almax
    disp(al);
    tic
    x = ones(1, size(0:10:al, 2));          % unitary vector for frame2
    param.frames{2}.sites = sum(x);         % sets new parameters for frame2
    param.frames{2}.cq_phi = 0*x;           %
    param.frames{2}.cq_theta = beta2*x;     %
    param.frames{2}.cq_psi = 0:10:al;       %
    param.frames{2}.csa_phi = 0*x;          %
    param.frames{2}.csa_theta = 0*x;        %
    param.frames{2}.csa_psi = 0*x;          %
    param.sites_total = 3*sum(x);           % number of all sites
    param.cq = CQ*ones(1,3*sum(x));         % cq vector for oneframe (don't know why it doesn't update automatically)
    param.eta= 0*ones(1,3*sum(x));          % eta vector for oneframe (see above)
    newparam = rebuild(param,'CQangles');   % updates the oneframeangleset for equal population
    param=newparam;                         %
    sitepop = kron(x, frame1);              % vector of the unequal population
    param.wts = sitepop/sum(sitepop);       % normalisation of this vector
    newparam = rebuild(param, 'rates');     % updates ratematrix for unequal populations
    param=newparam;                         %
    newfids = staticsim(param);             % does the QE simulation
    npts_newfid = size(newfids, 1);         % lenght of the calculated fid
    newfids(npts_newfid+1:npts_exp) = zeros;% zerofilling
    fids{al/10-almin/10+1} = newfids;       % stores the fids
    params{al/10-almin/10+1} = param;       % stores the parametersets
    multiprocjulia                          % processes the spectra; takes default procesing parameters from startfile
    specs{al/10-almin/10+1} = spec;         % stores the spectra
    toc
end

    
    


