% script to generate library of threesite jump angles

clear ;   % clean out the workspace : NOTE save important results BEFORE RUNNING THIS SCRIPT
gamma = [20 40 60 80 100 120 140 160 180 200 220 240 260 280 300 320 340 ]; % range of jump angles
load threesite.fig_param.mat   % Change the .mat filename to load the one you want to start with
%
% specify new parameters: site populations, powder increments, eta, cq,
% etc. Modify and unncomment lines as desired 
%

param.n = 6725; % this is also the value in the twosite param file
ng = length(gamma)
np = size(param.fid,1);
sigs = zeros(np,ng);
npar = param;
tic  % start timer
for ll = 1:ng                                   % (big) loop over distribution samples
    display(ll)                                 % print loop counter in case user gets bored
    npar.frames{1}.cq_psi = [0 gamma(ll)/2 gamma(ll)];          % reset jump angle
    npar = rebuild(npar,'CQangles');
    sigs(:,ll) = staticsim(npar);              % re-run the simulation
end
toc
[specs,fax] = mpr(param,sigs); %  column j of specs is the line shape for the j-th jump angle
save threesite_jumplib