function varargout = showmodel(varargin)
% SHOWMODEL M-file for showmodel.fig
%      SHOWMODEL, by itself, creates a new SHOWMODEL or raises the existing
%      singleton*.
%
%      H = SHOWMODEL returns the handle to a new SHOWMODEL or the handle to
%      the existing singleton*.
%
%      SHOWMODEL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SHOWMODEL.M with the given input arguments.
%
%      SHOWMODEL('Property','Value',...) creates a new SHOWMODEL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before showmodel_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to showmodel_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help showmodel

% Last Modified by GUIDE v2.5 19-Feb-2008 13:57:31

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @showmodel_OpeningFcn, ...
                   'gui_OutputFcn',  @showmodel_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before showmodel is made visible.
function showmodel_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to showmodel (see VARARGIN)

% Choose default command line output for showmodel
handles.output = hObject;
createAxesButton('axes1','\alpha ',18,'bold',[0.9,0.5]);
createAxesButton('axes2','\beta ',18,'bold',[0.9,0.5]);
createAxesButton('axes3','\gamma ',18,'bold',[0.9,0.5]);
data = struct('siteangles',[],'model',[],'template',[],... % site deffinitions
    'R1',eye(3),...                          % Cartesian rotation matrix for R1
    'hfig',[],...                            % handle for display figure
    'ht',[],...                              % handle(s) for tensor object to be rotated
    'vrxs',[],...                            % j-th column is starting coordinate for rotated x-vector for site j
    'vrxe',[],...                            % j-th column is starting coordinate for rotated y-vector for site j
    'vrys',[],...                            % j-th column is starting coordinate for rotated z-vector for site j
    'vrye',[],...                            % j-th column is end coordinate for rotated x-vector for site j
    'vrzs',[],...                            % j-th column is end coordinate for rotated y-vector for site j
    'vrze',[],...                            % j-th column is end coordinate for rotated z-vector for site j
    'vxzero',[],...                          % start,end of unrotated x-vector
    'vyzero',[],...                          % start,end of unrotated y-vector
    'vzzero',[]);                            % start,end of unrotated z-vector

data.siteangles = varargin{1};
data.model = varargin{2};
data.template = varargin{3};
set(findobj('tag','angles'),'String',sprintf('%18.3f',data.siteangles(1,1),data.siteangles(1,2),data.siteangles(1,3)));
set(findobj('tag','start_anim'),'visible','on')
set(findobj('tag','stop_ani'),'visible','off')
set(findobj('tag','speed'),'userdata',0.95,'value', 0.95);
nsites = size(data.siteangles,1);
sitelabels = cell(nsites,1);
for jj = 1:nsites
    sitelabels{jj} = sprintf('%s%d','Site ',jj);
    set(findobj('tag','siteselect'),'String',sitelabels)
end
hfig = figure(5); % draw the starting figure
v = [2 0 0]' ; z = [0 0 0]';%z2 = [0 0]; 
hax = plot3(v,z,z,'k--',-v,z,z,'k--') ; hold on ;
hay = plot3(z,v,z,'b--',z,-v,z,'b--');
haz = plot3(z,z,v,'r--',z,z,-v,'r--');
vx = [.4 0 ; 0 0; 1 1]; % first column is endpoint, second column is start point for Vx initially along X-axis
vy = [0 0 ; .3 0; 1 1] ;% first column is endpoint, second column is start point for Vy initially along Y-axis
vz = [0 0 ; 0 0; 1.5 0] ; % first column is endpoint, second column is start point for Vz initially along Z-axis
htx = plot3(vx(1,:),vx(2,:),vx(3,:),'k','Linewidth',3);
hty = plot3(vy(1,:),vy(2,:),vy(3,:),'b','Linewidth',3);
htz = plot3(vz(1,:),vz(2,:),vz(3,:),'r','Linewidth',3);
vxs = [vx(1,1) ; vx(2,1); vx(3,1)];
vxe = [vx(1,2) ; vx(2,2); vx(3,2)];
vys = [vy(1,1) ; vy(2,1); vy(3,1)];
vye = [vy(1,2) ; vy(2,2); vy(3,2)];
vzs = [vz(1,1) ; vz(2,1); vz(3,1)];
vze = [vz(1,2) ; vz(2,2); vz(3,2)];
for jj = 1:nsites % compute rotated vectors for each site
    angles = -fliplr(data.siteangles(jj,:)); % show the rotation LAB ==> PAS, i.e., the inverse of the input angles PAS==>LAB 
    R = rmat(angles);
    vs = R*[vxs vys vzs];
    ve = R*[vxe vye vze];
    data.vrxs(:,jj) = vs(:,1);
    data.vrxe(:,jj) = ve(:,1);
    data.vrys(:,jj) = vs(:,2);
    data.vrye(:,jj) = ve(:,2);
    data.vrzs(:,jj) = vs(:,3);
    data.vrze(:,jj) = [0 0 0]'; % z-vectors always start at the origin
end
data.vxzero = vx;
data.vyzero = vy;
data.vzzero = vz;
hx = text(2.15,0.1,-0.05,'X','Fontsize',16,'Color','black');
hy = text(0,2.3,0,'Y','Fontsize',16,'Color','blue');
hz = text(-0.1,0,2.3,'Z','Fontsize',16,'Color','red');
hold off
view(-37.5,25)% makes a pleasing perspective
axis square
axis off
ht = [htx ; hty ;htz]; % handle(s) for tensor object
set(ht,'erasemode','background') ; % this speeds up the drawing
data.ht = ht;
data.hfig = hfig;
handles.data = data;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes showmodel wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = showmodel_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output; 

% --- Executes on button press in exit.
function exit_Callback(hObject, eventdata, handles)
% hObject    handle to exit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
closereq;
close(handles.data.hfig);


% --- Executes on selection change in siteselect.
function siteselect_Callback(hObject, eventdata, handles)
% hObject    handle to siteselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns siteselect contents as cell array
%        contents{get(hObject,'Value')} returns selected item from siteselect
data = handles.data;
row = get(hObject,'value');
angles = data.siteangles(row,:);
set(findobj('tag','angles'),'String',sprintf('%18.3f',angles(1),angles(2),angles(3))); 
v = [2 0 0]' ; z = [0 0 0]';%z2 = [0 0]; 
figure(handles.data.hfig);
hax = plot3(v,z,z,'k--',-v,z,z,'k--') ; hold on ;
hay = plot3(z,v,z,'b--',z,-v,z,'b--');
haz = plot3(z,z,v,'r--',z,z,-v,'r--');
sitenum = row;
vrxs = data.vrxs(:,sitenum);
vrxe = data.vrxe(:,sitenum);
vrys = data.vrys(:,sitenum);
vrye = data.vrye(:,sitenum);
vrzs = data.vrzs(:,sitenum);
vrze = data.vrze(:,sitenum);
vx = [vrxs(1) vrxe(1) ; vrxs(2) vrxe(2); vrxs(3) vrxe(3)]; % first column is endpoint, second column is start point for Vx in selected site
vy = [vrys(1) vrye(1) ; vrys(2) vrye(2); vrys(3) vrye(3)]; % first column is endpoint, second column is start point for Vx in selected site
vz = [vrzs(1) vrze(1) ; vrzs(2) vrze(2); vrzs(3) vrze(3)]; % first column is endpoint, second column is start point for Vx in selected site
htx = plot3(vx(1,:),vx(2,:),vx(3,:),'k','Linewidth',3);
hty = plot3(vy(1,:),vy(2,:),vy(3,:),'b','Linewidth',3);
htz = plot3(vz(1,:),vz(2,:),vz(3,:),'r','Linewidth',3);
hx = text(2.15,0.1,-0.05,'X','Fontsize',16,'Color','black');
hy = text(0,2.3,0,'Y','Fontsize',16,'Color','blue');
hz = text(-0.1,0,2.3,'Z','Fontsize',16,'Color','red');
hold off
view(-37.5,25)% makes a pleasing perspective
axis square
axis off

% --- Executes during object creation, after setting all properties.
function siteselect_CreateFcn(hObject, eventdata, handles)
% hObject    handle to siteselect (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%
% UTILITY FUNCTIONS
% 
function createAxesButton(tag,string,fontsize,fontweight,pos)
text_obj = text('Parent',findobj('tag',tag),...
    'Position',pos,...
    'String',string,...
    'Interpreter','tex',...
    'HorizontalAlignment','right',...
    'VerticalAlignment','middle',...
    'FontName','Times',...
    'FontSize',18,...
    'FontAngle','normal',...
    'FontWeight','bold',...
    'Color',[0 0 1]);


function R = rmat(a)
% computes 3x3 rotation matrix for Euler rotation ([alpha,beta,gamma] (in RADIANS!)
% uses standard Rose conventions: 
%   R(z,alfa)             -- counterclockwise about z, a degrees
%   next, R(y1,beta)      -- counterclockwise about y1, b degrees
%   finally, R(z2, gamma) -- counterclockwise about z2, g degrees
%
%   NOTE: this is implemented as the equivalent rotation
%         R = R(z,gamma)R(y,beta)R(z,alfa)
%
a = a*pi/180;
cg = cos(a(3)); sg = sin(a(3));
cb = cos(a(2)); sb = sin(a(2));
ca = cos(a(1)); sa = sin(a(1));
Rg=[ cg -sg 0;
    sg cg 0;
    0  0 1];
Rb=[cb   0 sb;
    0    1   0;
    -sb  0 cb];
Ra=[ ca -sa 0;
    sa ca 0;
    0   0 1];
R=Ra*Rb*Rg; 


% % --- Executes on button press in showsite.
% function showsite_Callback(hObject, eventdata, handles)
% % hObject    handle to showsite (see GCBO)
% % eventdata  reserved - to be defined in a future version of MATLAB
% % handles    structure with handles and user data (see GUIDATA)
% data = handles.data;
% figure(data.hfig); 
% v = [2 0 0]' ; z = [0 0 0]';%z2 = [0 0]; 
% hax = plot3(v,z,z,'k--',-v,z,z,'k--') ; hold on ;
% hay = plot3(z,v,z,'b--',z,-v,z,'b--');
% haz = plot3(z,z,v,'r--',z,z,-v,'r--');
% sitenum = get(findobj('tag','siteselect'),'value');
% vrxs = data.vrxs(:,sitenum);
% vrxe = data.vrxe(:,sitenum);
% vrys = data.vrys(:,sitenum);
% vrye = data.vrye(:,sitenum);
% vrzs = data.vrzs(:,sitenum);
% vrze = data.vrze(:,sitenum);
% vx = [vrxs(1) vrxe(1) ; vrxs(2) vrxe(2); vrxs(3) vrxe(3)]; % first column is endpoint, second column is start point for Vx in selected site
% vy = [vrys(1) vrye(1) ; vrys(2) vrye(2); vrys(3) vrye(3)]; % first column is endpoint, second column is start point for Vx in selected site
% vz = [vrzs(1) vrze(1) ; vrzs(2) vrze(2); vrzs(3) vrze(3)]; % first column is endpoint, second column is start point for Vx in selected site
% htx = plot3(vx(1,:),vx(2,:),vx(3,:),'k','Linewidth',3);
% hty = plot3(vy(1,:),vy(2,:),vy(3,:),'b','Linewidth',3);
% htz = plot3(vz(1,:),vz(2,:),vz(3,:),'r','Linewidth',3);
% hx = text(2.15,0.1,-0.05,'X','Fontsize',16,'Color','black');
% hy = text(0,2.3,0,'Y','Fontsize',16,'Color','blue');
% hz = text(-0.1,0,2.3,'Z','Fontsize',16,'Color','red');
% hold off
% view(-37.5,15)% makes a pleasing perspective
% axis square
% axis off
% --- Executes on button press in showall.
function showall_Callback(hObject, eventdata, handles)
% hObject    handle to showall (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = handles.data;
figure(data.hfig); 
v = [2 0 0]' ; z = [0 0 0]';%z2 = [0 0]; 
hax = plot3(v,z,z,'k--',-v,z,z,'k--') ; hold on ;
hay = plot3(z,v,z,'b--',z,-v,z,'b--');
haz = plot3(z,z,v,'r--',z,z,-v,'r--');
sitenum = size(data.siteangles,1);
for jj = 1:sitenum
    vrxs = data.vrxs(:,jj);
    vrxe = data.vrxe(:,jj);
    vrys = data.vrys(:,jj);
    vrye = data.vrye(:,jj);
    vrzs = data.vrzs(:,jj);
    vrze = data.vrze(:,jj);
    vx = [vrxs(1) vrxe(1) ; vrxs(2) vrxe(2); vrxs(3) vrxe(3)]; % first column is endpoint, second column is start point for Vx in selected site
    vy = [vrys(1) vrye(1) ; vrys(2) vrye(2); vrys(3) vrye(3)]; % first column is endpoint, second column is start point for Vx in selected site
    vz = [vrzs(1) vrze(1) ; vrzs(2) vrze(2); vrzs(3) vrze(3)]; % first column is endpoint, second column is start point for Vx in selected site
    htx(jj) = plot3(vx(1,:),vx(2,:),vx(3,:),'k','Linewidth',3);
    hty(jj) = plot3(vy(1,:),vy(2,:),vy(3,:),'b','Linewidth',3);
    htz(jj) = plot3(vz(1,:),vz(2,:),vz(3,:),'r','Linewidth',3);
end
hx = text(2.15,0.1,-0.05,'X','Fontsize',16,'Color','black');
hy = text(0,2.3,0,'Y','Fontsize',16,'Color','blue');
hz = text(-0.1,0,2.3,'Z','Fontsize',16,'Color','red');
hold off
view(-37.5,25)% makes a pleasing perspective
axis square
axis off

% --- Executes on selection change in model.
function model_Callback(hObject, eventdata, handles)
% hObject    handle to model (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns model contents as cell array
%        contents{get(hObject,'Value')} returns selected item from model


% --- Executes during object creation, after setting all properties.
function model_CreateFcn(hObject, eventdata, handles)
% hObject    handle to model (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
data = handles.data;
set(findobj('tag','angles'),'String',sprintf('%18.3f',data.siteangles(1,1),data.siteangles(1,2),data.siteangles(1,3)));
nsites = size(data.siteangles,1);
sitelabels = cell(nsites,1);
for jj = 1:nsites
    sitelabels{jj} = sprintf('%s%d','Site ',jj);
    set(findobj('tag','siteselect'),'String',sitelabels)
end
 figure(data.hfig); % draw the starting figure
v = [2 0 0]' ; z = [0 0 0]';%z2 = [0 0]; 
hax = plot3(v,z,z,'k--',-v,z,z,'k--') ; hold on ;
hay = plot3(z,v,z,'b--',z,-v,z,'b--');
haz = plot3(z,z,v,'r--',z,z,-v,'r--');
vx = [.4 0 ; 0 0; 1 1]; % first column is endpoint, second column is start point for Vx initially along X-axis
vy = [0 0 ; .3 0; 1 1] ;% first column is endpoint, second column is start point for Vy initially along Y-axis
vz = [0 0 ; 0 0; 1.5 0] ; % first column is endpoint, second column is start point for Vz initially along Z-axis
htx = plot3(vx(1,:),vx(2,:),vx(3,:),'k','Linewidth',3);
hty = plot3(vy(1,:),vy(2,:),vy(3,:),'b','Linewidth',3);
htz = plot3(vz(1,:),vz(2,:),vz(3,:),'r','Linewidth',3);
vxs = [vx(1,1) ; vx(2,1); vx(3,1)];
vxe = [vx(1,2) ; vx(2,2); vx(3,2)];
vys = [vy(1,1) ; vy(2,1); vy(3,1)];
vye = [vy(1,2) ; vy(2,2); vy(3,2)];
vzs = [vz(1,1) ; vz(2,1); vz(3,1)];
vze = [vz(1,2) ; vz(2,2); vz(3,2)];
hx = text(2.15,0.1,-0.05,'X','Fontsize',16,'Color','black');
hy = text(0,2.3,0,'Y','Fontsize',16,'Color','blue');
hz = text(-0.1,0,2.3,'Z','Fontsize',16,'Color','red');
hold off
view(-37.5,25)% makes a pleasing perspective
axis square
axis off
set(findobj('tag','start_anim'),'visible','on')
set(findobj('tag','stop_ani'),'visible','off')

% --- Executes on button press in start_anim.
function start_anim_Callback(hObject, eventdata, handles)
% hObject    handle to start_anim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'visible','off')
set(findobj('tag','stop_ani'),'visible','on')

data = handles.data;
figure(data.hfig);
v = [2 0 0]' ; z = [0 0 0]';%z2 = [0 0];
plot3(v,z,z,'k--',-v,z,z,'k--') ; hold on ;
plot3(z,v,z,'b--',z,-v,z,'b--');
plot3(z,z,v,'r--',z,z,-v,'r--');
sitenum = size(data.siteangles,1);
htx = zeros(1,sitenum);
hty = zeros(1,sitenum);
htz = zeros(1,sitenum);
for jj = 1:sitenum
    vrxs = data.vrxs(:,jj);
    vrxe = data.vrxe(:,jj);
    vrys = data.vrys(:,jj);
    vrye = data.vrye(:,jj);
    vrzs = data.vrzs(:,jj);
    vrze = data.vrze(:,jj);
    vx = [vrxs(1) vrxe(1) ; vrxs(2) vrxe(2); vrxs(3) vrxe(3)]; % first column is endpoint, second column is start point for Vx in selected site
    vy = [vrys(1) vrye(1) ; vrys(2) vrye(2); vrys(3) vrye(3)]; % first column is endpoint, second column is start point for Vx in selected site
    vz = [vrzs(1) vrze(1) ; vrzs(2) vrze(2); vrzs(3) vrze(3)]; % first column is endpoint, second column is start point for Vx in selected site
    htx(jj) = plot3(vx(1,:),vx(2,:),vx(3,:),'k','Linewidth',3);
    hty(jj) = plot3(vy(1,:),vy(2,:),vy(3,:),'b','Linewidth',3);
    htz(jj) = plot3(vz(1,:),vz(2,:),vz(3,:),'r','Linewidth',3);
end
text(2.15,0.1,-0.05,'X','Fontsize',16,'Color','black');
text(0,2.3,0,'Y','Fontsize',16,'Color','blue');
text(-0.1,0,2.3,'Z','Fontsize',16,'Color','red');
hold off
view(-37.5,25)% makes a pleasing perspective
axis square
axis off
set(hObject,'userdata','on') % reset flag to permit animation
tm = 1-get(findobj('tag','speed'),'userdata');
while abs(tm-1) > 0.01
    if isequal(get(hObject,'userdata'),'on') % keep on truckin...
        tm = 1-get(findobj('tag','speed'),'userdata');
        for kk = 1: sitenum
            for jj = 1:sitenum
                if ~isequal(data.template(jj,kk), 0)
                    set( [htx hty htz], 'visible','off');
                    pause(.01+tm);
                    set([htx(jj) hty(jj) htz(jj)],'visible','on')
                    pause(.02+1.5*tm)
                end
            end
        end
    else % user pushed stop button
        set(findobj('tag','start_anim'),'visible','on')
        set(findobj('tag','stop_ani'),'visible','off')
        return
    end
end
% --- Executes on button press in stop_ani.
function stop_ani_Callback(hObject, eventdata, handles)
% hObject    handle to stop_ani (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(findobj('tag','start_anim'),'visible','on','userdata','stop')
set(findobj('tag','stop_ani'),'visible','off')


% --- Executes on slider movement.
function speed_Callback(hObject, eventdata, handles)
% hObject    handle to speed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
set(hObject,'userdata',get(hObject,'value')); % store the value for use by start_ani callback routine

% --- Executes during object creation, after setting all properties.
function speed_CreateFcn(hObject, eventdata, handles)
% hObject    handle to speed (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


