function amatrix = CSA_hmatrix(wconstant,k,omegas,n)
% amatrix=CSA_hmatrix(wconstant,diso,k,omegas,n)
% for many site jumping dynamic problem.
% for 2H-MAS
% This routine adds bands from the one-frame k-matrix to the large
% Floquet matrix for CSA
%@ RLV.
sitenumber=size(wconstant,1);
amatrix=zeros((2*n+1)*sitenumber);

kk=0;
for ii=-n:n
    for jj=1:sitenumber   
    amatrix(sitenumber*kk+jj,sitenumber*kk+jj)=  wconstant(jj,3)/omegas+ii;
    end
    blockindex=sitenumber*kk;
    amatrix(blockindex+1:blockindex+sitenumber,blockindex+1:blockindex+sitenumber)=...
        amatrix(blockindex+1:blockindex+sitenumber,blockindex+1:blockindex+sitenumber)-i*k/omegas;
    kk=kk+1;
end

kk=0;
for ii=-n:n-1
    for jj=1:sitenumber
    amatrix(sitenumber*kk+jj,sitenumber*(kk+1)+jj)=wconstant(jj,4)/omegas;
    amatrix(sitenumber*(kk+1)+jj,sitenumber*kk+jj)=wconstant(jj,2)/omegas;
    end
    kk=kk+1;
end

kk=0;
for ii=-n:n-2
    for jj=1:sitenumber
    amatrix(sitenumber*kk+jj,sitenumber*(kk+2)+jj)=wconstant(jj,5)/omegas;
    amatrix(sitenumber*(kk+2)+jj,sitenumber*kk+jj)=wconstant(jj,1)/omegas;    
    end
    kk=kk+1;
end


