function D = D4(a,b,g)
% D = D4(a,b,g) returns 4-th rank Wigner rotation matrix for Euler Angles (a,b,g)
% reduced matrix element formulae from C. Zannoni in "NMR of Liquid
% Crystals" , J.W. Emsley, Ed.NATO ASI Ser., Ser. C 141, 1 (1985).
% input angles in Radians, NOT degrees!

cb = cos(b) ; sb = sin(b); c2b = cos(2*b); s2b = sin(2*b);
c3b = cos(3*b); s3b = sin(3*b);
c4b = cos(4*b); s4b = sin(4*b);
s = [sb s2b s3b s4b]' ; c = [cb c2b c3b c4b]';
%
% THE MAZE OF TWISTY LITTLE PASSAGES, ALL DIFFERENT...
%
d44 = [35 56 28  8 1]*[1;c]/128;  dm4m4 = d44; 
d43  = sqrt(2)*[-14 -14 -6 -1]*s/64; dm3m4 = d43; d34 = -d43; dm4m3 = -d43;
d42 = sqrt(7)*[5 4 -4 -4 -1 ]*[1;c]/64; dm4m2 = d42; d24 = d42 ; dm2m4 = d42;
d41 = sqrt(14)*[-6 -2 2 1]*s/64; d14 = -d41 ; dm4m1 = -d41; dm1m4 = d41;
d40 = sqrt(70)*sb^4/16; dm40 = d40 ; d04 = d40 ; d0m4 = d40;
d4m1 =sqrt(14)*[-6 2 2 -1]*s/64; d1m4 = d4m1 ; dm14 = -d4m1 ; dm41 = -d4m1;
d4m2 =sqrt(7)*[5 -4 -4 4 -1 ]*[1;c]/64; dm42 = d4m2 ; dm24 = d4m2 ; d2m4 = d4m2;
d4m3  = sqrt(2)*[-14 14 -6 1]*s/64; d3m4 = d4m3; dm43 = -d4m3; dm34 = -d4m3;
d4m4 = [35 -56 28  -8 1]*[1;c]/128;  dm44 = d4m4;
d33 = [7 14 9 2]*c/32; dm3m3 = d33;
d32 = sqrt(14)*[1 -2 -3 -1]*s/32; dm2m3 = d32 ; dm3m2 = -d32 ; d23 = -d32;
d31 = sqrt(7)*[3 2 -3 -2]*c/32; d13 = d31 ; dm3m1 = d31 ; dm1m3 = d31;
d30 = sqrt(35)*(-2*s2b+s4b)/32; d0m3 = d30 ; d03 = -d30 ; dm30 = -d30;
d3m1 = sqrt(7)*[3 -2 -3 2]*c/32; dm31 = d3m1 ; dm13 = d3m1 ; d1m3 = d3m1;
d3m2 = sqrt(14)*[-1 -2 3 -1]*s/32; d2m3 = d3m2 ; dm32 = -d3m2 ; dm23 = -d3m2;
d3m3 = [7 -14 9 -2]*c/32; dm33 = d3m3;
d22 = [5 2 4 14 7]*[1;c]/32 ; dm2m2 = d22;
d21 = sqrt(2)*[-6 4 -14 -14]*s/64; dm1m2 = d21 ; d12 = -d21 ; dm2m1 = -d21;
d20 = sqrt(10)*(3+4*c2b-7*c4b)/64 ; d02 = d20 ; dm20 = d20 ; d0m2 = d20;
d2m1 = sqrt(2)*[-3 -2 -7 7]*s/32 ; d1m2 = d2m1 ; dm21 = -d2m1 ; dm12 = -d2m1;
d2m2 = [5 -2 4 -14 7]*[1;c]/32 ; dm22 = d2m2;
d11 = [9 2 7 14]*c/32; dm1m1 = d11;
d10 = -sqrt(5)*(2*s2b+7*s4b)/32; d0m1 = d10 ; dm10 = -d10 ; d01 = -d10;
d1m1 = [9 -2 7 -14]*c/32; dm11 = d1m1;
d00 = (9+20*c2b+35*c4b)/64;
m = [4 3 2 1 0 -1 -2 -3 -4]; exp_alfa = exp(+i*m*a); exp_gamma = exp(-i*m*g);
% reduced Wigner d4(m,n)
D = [d44  d43  d42  d41  d40  d4m1  d4m2  d4m3  d4m4 ;...
     d34  d33  d32  d31  d30  d3m1  d3m2  d3m3  d3m4 ; ...
     d24  d23  d22  d21  d20  d2m1  d2m2  d2m3  d2m4 ; ...
     d14  d13  d12  d11  d10  d1m1  d1m2  d1m3  d1m4 ; ...
     d04  d03  d02  d01  d00  d0m1  d0m2  d0m3  d0m4 ; ...
     dm14 dm13 dm12 dm11 dm10 dm1m1 dm1m2 dm1m3 dm1m4; ...
     dm24 dm23 dm22 dm21 dm20 dm2m1 dm2m2 dm2m3 dm2m4; ...
     dm34 dm33 dm32 dm31 dm30 dm3m1 dm3m2 dm3m3 dm3m4; ...
     dm44 dm43 dm42 dm41 dm40 dm4m1 dm4m2 dm4m3 dm4m4];
 D = D.*(exp_alfa'*exp_gamma);
 
 