function wconst=DSIM_wconstant(phi,theta,beta,siteangles,siteqconst,siteasyconst)
%wconst=DISM_wconstant(phi,theta,beta,siteangles,siteqconst,siteasyconst)
%asyconst=(qxx-qyy)/qzz (0.1-1)
%qconst=e^2*q*Q/h quadrupole coupling constant
%for 2H-MAS.
%@ Y.Y.H    

sitewq=siteqconst*4/3; % already in rad/sec!*2*pi;

sitenumb=size(siteangles,1);
wconst=zeros(sitenumb,5);

p=phi; 
t=theta; 

%Dpt=new_wigner(p,t,0);

Dpt=DSIM_wigner(p,t,0);
Db=DSIM_wigner(0,beta,0);

%  D  2  1  0 -1 -2
%  2  a  b  c  d  e
%  1 -b  f  g  h  d
%  0  c -g  k  g  c
% -1 -d  h -g  f  b
% -2  e -d  c -b  a

for ii=1:sitenumb

    asyconst=siteasyconst(ii);
    wq=sitewq(ii);
    T0=sqrt(3/8)*wq;
    T2=asyconst/4*wq;

    a=siteangles(ii,1);
    b=siteangles(ii,2);
    g=siteangles(ii,3);
    sb=sin(b);
    cb=cos(b);


    A=(3/2*cb*cb-1/2)*T0+(exp(-i*2*a)+exp(i*2*a))*sqrt(3/8)*sb*sb*T2;
    B=sqrt(3/2)*sb*cb*exp(-i*g)*T0+exp(-i*2*a)*(-(1+cb)/2*sb)*exp(-i*g)*T2+exp(i*2*a)*((1-cb)/2*sb)*exp(-i*g)*T2;
    %C=-sqrt(3/2)*sb*cb*exp(i*g)*T0+exp(-i*2*a)*(-(1-cb)/2*sb)*exp(i*g)*T2+exp(i*2*a)*((1+cb)/2*sb)*exp(i*g)*T2;
    C = -conj(B);
    D=sqrt(3/8)*sb*sb*exp(-2*i*g)*T0+exp(-i*2*a)*((1+cb)/2)^2*exp(-2*i*g)*T2+exp(i*2*a)*((1-cb)/2)^2*exp(-2*i*g)*T2;
    %E=sqrt(3/8)*sb*sb*exp(2*i*g)*T0+exp(-i*2*a)*((1-cb)/2)^2*exp(2*i*g)*T2+exp(i*2*a)*((1+cb)/2)^2*exp(2*i*g)*T2;
    E = conj(D);

    % w(1 2 3 4 5)= w(2 1 0 -1 -2)
    V = [D B A C E];
    %wconst(ii,1)=Db(1,3)*sum(Dpt(:,1)'.*[D B A C E]);
    %wconst(ii,2)=Db(2,3)*sum(Dpt(:,2)'.*[D B A C E]);
    %wconst(ii,3)=Db(3,3)*sum(Dpt(:,3)'.*[D B A C E]);
    %wconst(ii,4)=Db(4,3)*sum(Dpt(:,4)'.*[D B A C E]);
    %wconst(ii,5)=Db(5,3)*sum(Dpt(:,5)'.*[D B A C E]);
wconst(ii,1)=Db(1,3)*V*conj(Dpt(:,1));
wconst(ii,2)=Db(2,3)*V*conj(Dpt(:,2));
wconst(ii,3)=Db(3,3)*V*conj(Dpt(:,3));
%wconst(ii,4)=Db(4,3)*V*Dpt(:,4);
%wconst(ii,5)=Db(5,3)*V*Dpt(:,5);
wconst(ii,4)= conj(wconst(ii,2)) ;
wconst(ii,5) = conj(wconst(ii,1));
end
