function D=DSIM_wigner(alpha,beta,gamma)
% D=DSIM_wigner(alpha,beta,gamma)
% returns the 5x5 second rank Wigner rotation matrix
% Euler angles (radians) defined according to Rose conventions



cb=cos(beta);
sb=sin(beta);

a=(1+cb)^2/4;
b=-(1+cb)/2*sb;
c=sqrt(6)/4*sb*sb;
d=-(1-cb)/2*sb;
e=(1-cb)^2/4;

f=(1+cb)*(2*cb-1)/2;
g=-sqrt(3/2)*sb*cb;
h=(1-cb)*(2*cb+1)/2;

k=(3/2*cb*cb-1/2)+i*00; %make sure the D00 is a complex number.

D=[ a  b  c  d  e
   -b  f  g  h  d
    c -g  k  g  c
   -d  h -g  f  b
    e -d  c -b  a ];

%  D  2  1  0 -1 -2
%  2  a  b  c  d  e
%  1 -b  f  g  h  d
%  0  c -g  k  g  c
% -1 -d  h -g  f  b
% -2  e -d  c -b  a

for m=2:-1:-2
    D(3-m,:)=exp(-i*m*alpha).*D(3-m,:);
end
for n=2:-1:-2
    D(:,3-n)=D(:,3-n).*exp(-i*n*gamma);
end

