function k=mergematrix(k1,k2)
%        k=mergematrix(k1,k2)   
%        k1 n*n k2 m*m
%        makes n copies of (mxm) matrix k1 along the diagonal, then
%        "connects" off-diagonal (nxn) sub-blocks j =1,...n-1  k = j+1,...n with (mxm) identity matrix times k2(j,k)
%        if k1 and k2 separately satisfy detailed balance, so does the
%        merged matrix
%        final version Y.Y.H
n=size(k1,1);
m=size(k2,1);

k=zeros(n*m);
% n copies of k1 along the diagonal
for ii=1:n
    for jj=ii+1:n
        for iii=1:m
           k((ii-1)*m+iii,(jj-1)*m+iii)=k1(ii,jj);
           k((jj-1)*m+iii,(ii-1)*m+iii)=k1(jj,ii) ;
       end 
   end
end
% off-diagonal (nxn) identity matrix blocks, each scaled by k2(iii,jjj)
for ii=1:n
    for iii=1:m
        for jjj=1:m
            k((ii-1)*m+iii,(ii-1)*m+jjj)=k2(iii,jjj);
        end
    end
end
% diagonal elements of final matrix
for ii=1:n
    for jj=1:m
    k((ii-1)*m+jj,(ii-1)*m+jj)=k1(ii,ii)+k2(jj,jj);
    end
end
c = 0;




