function data = phcor(sp,ph0,ph1,piv)
%   function data = ph(sp,ph0,ph1)
%	applies ph0 and ph1 to columns of sp
%   no checks done here for validity of piv, the pivot point for ph1
[m n]=size(sp);
if nargin < 4 piv = m/2 ; end % pivot about middle
if nargin < 3 ph1 = 0; end
if nargin < 2 ph0 = 0; end
phase = pi*ph0/180;
phase = phase + ph1*(pi/180)*([0:m-1]-piv)'/m;
data=sp.*(exp(i*phase)*ones(1,n));
