function spec = qft(param)
%
% Computes Fourier transform of EXPRESS time domain data (fids organized by
% columns in param.buf) . For all but 2H T1q simulations, this is just the
% ordinary transform of data returned by the simulation routine. 
%
% For 2H T1q, the simulation routine calculates ONE transition (only) that
% relaxes in accord with orientation dependent T1q = 3*J1(w0), starting
% from a state of UNIFORM excitation
% This routine simulates the ideal BBJB initial condition by 
% a) inverting the computed spectrum for negative frequencies
% b) 
spec = swap(fft(param.buf));
n2 = floor(size(param.buf,1)/2); % first n/2 points
switch param.experiment
    case '2H T1Q'
      spec(1:n2 ,:) = -spec(1:n2,:); % invert one side of spectrum
      spec = (spec-flipud(spec))/2;  % add the other transition (assumes ideal pulses,etc) 
    otherwise
        return
end