function s = shift2d(buf,val)
% s = shift2d(buf,val) shifts data in buf up and down (along each column)
%     val > 0 is a left shift, val < 0 is a right shift
%     shifts by non-integral number of points are computed using cubic spline interpolation
[m,n]=size(buf);
if (val == 0)
    s = buf;
    return
end
if(abs(val) > m)
    s = buf;
    return
end
% easy case of integer number of  shifts
if (rem(val,1) == 0)
    s=zeros(m,n);
    if (val>=0)
        s(1:m-val,:)=buf(val+1:m,:);
    else
        s(-val+1:m,:)=buf(1:m+val,:);
    end
    return
end
% non-integral number of points: round to first decimal place
v = fix(val) + 0.1*(round(10.*mod(val,1))) ;
% interpolate each column by splines
% interpolate nine points between each real data point
x = 1:m; xi = 1:0.1:m ;
% shift interpolated data  by 10*val
sh = fix(10*v);
for jj = 1:n
    yi = interp1(x',buf(:,jj),xi','spline');% hooray for MATLAB utility routines
    nn = size(yi,1);
    if sh >= 0
        yi = [yi(sh+1:nn); zeros(sh,1)];
    else
        yi = [zeros(-sh,1);yi(1:nn+sh)];
    end
    % extract every tenth point of shifted array
    sc = zeros(m,1) ;
    sc = yi(1:10:size(yi,1));
    s(:,jj) = sc;
end
